Lucene++ - a full-featured, c++ search engine
API Documentation

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Protected Member Functions
Lucene::ExactPhraseScorer Class Reference

`#include <ExactPhraseScorer.h>`

Inheritance diagram for Lucene::ExactPhraseScorer:

## Public Member Functions

| ExactPhraseScorer (const WeightPtr &weight, Collection< TermPositionsPtr > tps, Collection< int32_t > offsets, const SimilarityPtr &similarity, ByteArray norms)
virtual | ~ExactPhraseScorer ()
virtual String | getClassName ()
boost::shared_ptr< ExactPhraseScorer > | shared_from_this ()
Public Member Functions inherited from Lucene::PhraseScorer
| PhraseScorer (const WeightPtr &weight, Collection< TermPositionsPtr > tps, Collection< int32_t > offsets, const SimilarityPtr &similarity, ByteArray norms)
virtual | ~PhraseScorer ()
boost::shared_ptr< PhraseScorer > | shared_from_this ()
virtual int32_t | docID ()
| Returns the following:
virtual int32_t | nextDoc ()
| Advances to the next document in the set and returns the doc it is currently on, or `NO_MORE_DOCS` if there are no more docs in the set.
virtual double | score ()
| Returns the score of the current document matching the query. Initially invalid, until `nextDoc()` or `advance(int32_t)` is called the first time, or when called from within `Collector#collect`.
virtual int32_t | advance (int32_t target)
| Advances to the first beyond the current whose document number is greater than or equal to target. Returns the current document number or `NO_MORE_DOCS` if there are no more docs in the set.
double | currentFreq ()
| Phrase frequency in current doc as computed by phraseFreq().
virtual float | termFreq ()
virtual String | toString ()
| Returns a string representation of the object.
Public Member Functions inherited from Lucene::Scorer
| Scorer (const SimilarityPtr &similarity)
| Constructs a Scorer.
| Scorer (const WeightPtr &weight)
virtual | ~Scorer ()
boost::shared_ptr< Scorer > | shared_from_this ()
SimilarityPtr | getSimilarity ()
| Returns the Similarity implementation used by this scorer.
virtual void | score (const CollectorPtr &collector)
| Scores and collects all matching documents.
void | visitSubScorers (QueryPtr parent, BooleanClause::Occur relationship, ScorerVisitor *visitor)
void | visitScorers (ScorerVisitor *visitor)
Public Member Functions inherited from Lucene::DocIdSetIterator
virtual | ~DocIdSetIterator ()
boost::shared_ptr< DocIdSetIterator > | shared_from_this ()
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed.
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Return clone of this object.
virtual int32_t | hashCode ()
| Return hash code for this object.
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal.
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects.
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock.
virtual LuceneSignalPtr | getSignal ()
| Return this object signal.
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout.
virtual void | unlock ()
| Unlock this object.
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread.
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout.
virtual void | notifyAll ()
| Notify all threads waiting for signal.

## Static Public Member Functions

static String | _getClassName ()
Static Public Member Functions inherited from Lucene::PhraseScorer
static String | _getClassName ()
Static Public Member Functions inherited from Lucene::Scorer
static String | _getClassName ()
Static Public Member Functions inherited from Lucene::DocIdSetIterator
static String | _getClassName ()

## Protected Member Functions

virtual double | phraseFreq ()
| For a document containing all the phrase query terms, compute the frequency of the phrase in that document. A non zero frequency means a match. Note, that containing all phrase terms does not guarantee a match - they have to be found in matching locations.
Protected Member Functions inherited from Lucene::PhraseScorer
bool | doNext ()
| Next without initial increment.
void | init ()
void | sort ()
void | pqToList ()
void | firstToLast ()
Protected Member Functions inherited from Lucene::Scorer
virtual bool | score (const CollectorPtr &collector, int32_t max, int32_t firstDocID)
| Collects matching documents in a range. Hook for optimization. Note, firstDocID is added to ensure that `nextDoc()` was called before this method.
Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Additional Inherited Members

Data Fields inherited from Lucene::Scorer
WeightPtr | weight
Static Public Attributes inherited from Lucene::DocIdSetIterator
static const int32_t | NO_MORE_DOCS
| When returned by `nextDoc()`, `advance(int)` and `docID()` it means there are no more docs in the iterator.
Protected Attributes inherited from Lucene::PhraseScorer
WeightPtr | weight
Weight * | __weight = nullptr
ByteArray | norms
double | value
bool | firstTime
bool | more
PhraseQueuePtr | pq
std::vector< PhrasePositionsPtr > | _holds
PhrasePositions * | __first = nullptr
PhrasePositions * | __last = nullptr
double | freq
Protected Attributes inherited from Lucene::Scorer
SimilarityPtr | similarity
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Constructor & Destructor Documentation

## ◆ ExactPhraseScorer()

Lucene::ExactPhraseScorer::ExactPhraseScorer | ( | const WeightPtr & | weight,
|  | Collection< TermPositionsPtr > | tps,
|  | Collection< int32_t > | offsets,
|  | const SimilarityPtr & | similarity,
|  | ByteArray | norms )

References Lucene::PhraseScorer::norms, Lucene::Scorer::similarity, and Lucene::PhraseScorer::weight.

Referenced by _getClassName().

## ◆ ~ExactPhraseScorer()

virtual Lucene::ExactPhraseScorer::~ExactPhraseScorer | ( |  | ) |

virtual

## Member Function Documentation

## ◆ _getClassName()

String Lucene::ExactPhraseScorer::_getClassName | ( |  | ) |

inline static

References ExactPhraseScorer().

## ◆ getClassName()

virtual String Lucene::ExactPhraseScorer::getClassName | ( |  | ) |

inline virtual

Reimplemented from Lucene::PhraseScorer.

## ◆ phraseFreq()

virtual double Lucene::ExactPhraseScorer::phraseFreq | ( |  | ) |

protected virtual

For a document containing all the phrase query terms, compute the frequency of the phrase in that document. A non zero frequency means a match. Note, that containing all phrase terms does not guarantee a match - they have to be found in matching locations.

Returns
  frequency of the phrase in current doc, 0 if not found.

Implements Lucene::PhraseScorer.

## ◆ shared_from_this()

boost::shared_ptr< ExactPhraseScorer > Lucene::ExactPhraseScorer::shared_from_this | ( |  | ) |

inline

The documentation for this class was generated from the following file:

- ExactPhraseScorer.h

clucene.sourceforge.net